﻿using _123.Data.LocalData;
using _123.Data.LocalData.Entity;
using _123.Data.RemoteData.RemoteDatabase.DAO;
using _123.Domain.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Xml.Linq;

namespace _123.Data.Repository
{
    public class PresenceRepositoryImpl : IPresenceRepository

    {
        public List<PresenceDao> GetAllPresences
        { get; set; }

        public void AddPresence(PresenceDao presence)
        {
            PresenceDao? presenceLocal = GetAllPresences.FirstOrDefault();
            presenceLocal.UserID = presence.UserID;
            presenceLocal.Date = presence.Date;
            presenceLocal.IsAttedance = presence.IsAttedance;
            presenceLocal.LessonNumber = presence.LessonNumber;

        }

        public List<PresenceDao> GetPresenceByGroup(int groupId)
        {
            return GetAllPresences;
        }

        public List<PresenceDao> GetPresenceByGroupAndDate(int groupId, DateOnly date)
        {
            return GetAllPresences;
        }

        public bool UnCheckAttendence(int firstClass, int lastClass, DateOnly date, int userId)
        {
            var presToUpdate = GetAllPresences
                .Where(x => x.UserID == userId && x.LessonNumber >= firstClass
                && x.LessonNumber <= lastClass && x.Date == date).ToList();
            foreach (var presence in presToUpdate)
            {
                presence.IsAttedance = false;
            }
            return true;
        }

    }
}
