﻿using _123.Data.LocalData;
using _123.Data.LocalData.Entity;
using _123.Data.RemoteData.RemoteDatabase;
using _123.Data.RemoteData.RemoteDatabase.DAO;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _123.Data.Repository
{
    public class SQLPresenceRepositoryImpl : IPresenceRepository
    {
        private readonly RemoteDatabaseContext _remoteDatabaseContext;

        public SQLPresenceRepositoryImpl(RemoteDatabaseContext remoteDatabaseContext)
        {
            _remoteDatabaseContext = remoteDatabaseContext;
        }

        public void AddPresence(PresenceDao presence)
        {
            _remoteDatabaseContext.PresencesDaos.Add(presence);
            _remoteDatabaseContext.SaveChanges();
        }

        public List<PresenceDao> GetPresenceByGroup(int groupId)
        {
            return _remoteDatabaseContext.PresencesDaos
                .Where(p => p.GroupId == groupId)
                .ToList();
        }

        public List<PresenceDao> GetPresenceByGroupAndDate(int groupId, DateOnly date)
        {
            return _remoteDatabaseContext.PresencesDaos
                .Where(p => p.GroupId == groupId && p.Date == date)
                .ToList();
        }

        public bool UnCheckAttendence(int firstClass, int lastClass, DateOnly date, int userId)
        {
            var presToUpdate = _remoteDatabaseContext.PresencesDaos
                .Where(x => x.UserID == userId && x.LessonNumber >= firstClass
                && x.LessonNumber <= lastClass && x.Date == date).ToList();

            foreach (var presence in presToUpdate)
            {
                presence.IsAttedance = false;
            }

            _remoteDatabaseContext.SaveChanges();
            return true;
        }
    }
}
