﻿using _123.Data.ReportsHistory;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using _123.Domain.Models;
using _123.Data.LocalData.Entity;

namespace _123.Domain.UseCase
{
    public class GroupUseCase
    {
        private GroupRepositoryImpl _repositoryGroupImpl;
        public GroupUseCase(GroupRepositoryImpl repositoryGroupImpl)
        {
            _repositoryGroupImpl = repositoryGroupImpl;
        }
        public List<Group> GetAllGroups() => _repositoryGroupImpl.GetAllGroups()
             .Select(it => new Group { ID = it.ID, Name = it.Name }).ToList();

        public Group UpdateGroupName(Group grou)
        {
            GroupLocalEntity groupLocalEntity = new GroupLocalEntity { ID = grou.ID, Name = grou.Name };
            GroupLocalEntity? result = _repositoryGroupImpl.UpdateGroup(groupLocalEntity);
            if (result == null) throw new Exception("");
            Group? group = GetAllGroups().FirstOrDefault(it => it.ID == result!.ID);
            if (group == null) throw new Exception("");
            return new Group { ID = group.ID, Name = group.Name };
        }
    }
    
}
